const
  SELF_ADDR = 1;
  NUM_CH = 6;

var
  lastTick: cardinal;
  sbuf: string;
  Inputs: array[0..NUM_CH-1] of Single;

{$I crc16_modbus.pas}

procedure OnLoad();
begin
  crc16_init();
//  AddMsg('Plugin Loaded');
end;


function MakeMsg(DvcAddr, FuncN: byte; RegAddr, Data: word; const sData: string): string;
var
  CRC: Word;
begin
  Result := chr(DvcAddr) + chr(FuncN);
  if not((RegAddr and Data) = $FFFF) then
    Result := Result + chr(Hi(RegAddr)) + chr(Lo(RegAddr)) + chr(Hi(Data)) + chr(Lo(Data));
  if sData <> '' then
    Result := Result + chr(length(sData)) + sData;
  CRC := _CountBlockCrc16(Result);
  Result := Result + chr(Lo(CRC)) + chr(Hi(CRC));
end;

procedure Reset();
begin
  sbuf := '';
end;

function MakeChData(): string;
var
  s: string;
  i: Integer;
begin
  Result := '';
  for i := 0 to NUM_CH-1 do begin
    s := Data2Str(Inputs[i]);
    Result := Result + s[2] + s[1] + s[4] + s[3];
  end;
end;

procedure OnReceive();
var
  i: Integer;
  b: byte;
  len: Integer;
  CRC: word;
  func: byte;
  s: string;
begin
  if (GetTickCount() - lastTick > 500) or (length(sbuf) > 10000) then
    Reset();
  lastTick := GetTickCount();
  for i := 1 to Length(RD) do begin
    b := Ord(RD[i]);
    if sbuf = '' then
      if b <> SELF_ADDR then continue;
    sbuf := sbuf + chr(b); // <dvcaddr><func><radrH><radrL><QH><QL>[<len><data...>]<crcL><crcH>
    len := length(sbuf);
    if (len < 2) then continue;
    func := ord(sbuf[2]);
    if (func = 4) then
      if (len < (2+2+2+2)) then continue
      else begin // Read
        Send(MakeMsg(SELF_ADDR, func, $FFFF, $FFFF, MakeChData()));
      end
    else if (func = 16) then
      if (len < (2+2+2+2)) then Continue
      else if (len < (2+2+2+2 + 1+ord(sbuf[7]))) then Continue
      else begin // Write
        Send(MakeMsg(SELF_ADDR, func, 0, 0, ''));
      end;
    Reset();
  end;
end;

